class Configuration
  require 'google/cloud'
  require "google/cloud/storage"
  attr_accessor :cloud_project,
                :cloud_bucket,
                :tmp_bucket,
                :credentials_file

  def initialize
    @cloud_project = nil
    @cloud_bucket = nil
    @tmp_bucket = nil
    @credentials_file = nil
  end

  def check
    if cloud_bucket.nil? || cloud_project.nil? || credentials_file.nil?
      raise "Configurarion error: #{cloud_bucket}, #{cloud_project}, #{credentials_file}, check your 'config/initializers/fdarchivo.rb'.
EJ.:
#{ejemplo_initalizer}"
    else
      # Iniciar el bucket principal
      unless self.cloud_bucket.is_a?(Google::Cloud::Storage::Bucket)
        self.cloud_bucket = Google::Cloud.new(cloud_project, credentials_file)
                                .storage
                                .bucket(cloud_bucket)
      end
      # Iniciar el bucket temporal
      unless self.tmp_bucket.is_a?(Google::Cloud::Storage::Bucket)
        self.tmp_bucket = Google::Cloud.new(cloud_project, credentials_file)
                              .storage
                              .bucket(tmp_bucket)
      end
      # Comprobar que el bucket principal se ha iniciado bien
      unless self.cloud_bucket.is_a?(Google::Cloud::Storage::Bucket)
        raise "Configuration error: Bad init cloud_bucket."
      end
      # Comprobar que el bucket temporal se ha iniciado bien
      unless self.tmp_bucket.is_a?(Google::Cloud::Storage::Bucket)
        raise "Configuration error: Bad init tmp_bucket."
      end
      self
    end
  end
  private
  def ejemplo_initalizer
    'Fdarchivo.configure do |config|
      config.cloud_project = "name_project"
      config.cloud_bucket = "name_bucket"
      config.credentials_file = "#{Rails.root}/config/google.json"
    end'
  end
end
